diff --git a/gcc/testsuite/gcc.dg/analyzer/malloc-paths-9.c b/gcc/testsuite/gcc.dg/analyzer/malloc-paths-9.c
index 50d8765..6bee885 100644
--- a/gcc/testsuite/gcc.dg/analyzer/malloc-paths-9.c
+++ b/gcc/testsuite/gcc.dg/analyzer/malloc-paths-9.c
@@ -1,4 +1,4 @@
-/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events" } */
+/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fdiagnostics-show-caret" } */
 
 #include <stdlib.h>
 
@@ -9,21 +9,23 @@ void test_1 (void)
   free (ptr); /* { dg-warning "double-'free' of 'ptr'"  } */
 }
 /* { dg-begin-multiline-output "" }
+   NN |   free (ptr);
+      |   ^~~~~~~~~~
   'test_1': events 1-3
-      |
-      |   NN |   void *ptr = malloc (1024);
-      |      |               ^~~~~~~~~~~~~
-      |      |               |
-      |      |               (1) allocated here
-      |   NN |   free (ptr);
-      |      |   ~~~~~~~~~~   
-      |      |   |
-      |      |   (2) first 'free' here
-      |   NN |   free (ptr);
-      |      |   ~~~~~~~~~~   
-      |      |   |
-      |      |   (3) second 'free' here; first 'free' was at (2)
-      |
+    |
+    |   NN |   void *ptr = malloc (1024);
+    |      |               ^~~~~~~~~~~~~
+    |      |               |
+    |      |               (1) allocated here
+    |   NN |   free (ptr);
+    |      |   ~~~~~~~~~~   
+    |      |   |
+    |      |   (2) first 'free' here
+    |   NN |   free (ptr);
+    |      |   ~~~~~~~~~~   
+    |      |   |
+    |      |   (3) second 'free' here; first 'free' was at (2)
+    |
    { dg-end-multiline-output "" } */
 
 void test_2 (int x, int y)
@@ -37,58 +39,62 @@ void test_2 (int x, int y)
 
 /* "double-'free' of 'ptr'".  */
 /* { dg-begin-multiline-output "" }
+   NN |     free (ptr);
+      |     ^~~~~~~~~~
   'test_2': events 1-7
-      |
-      |   NN |   void *ptr = malloc (1024);
-      |      |               ^~~~~~~~~~~~~
-      |      |               |
-      |      |               (1) allocated here
-      |   NN |   if (x)
-      |      |      ~         
-      |      |      |
-      |      |      (2) following 'true' branch (when 'x != 0')...
-      |   NN |     free (ptr);
-      |      |     ~~~~~~~~~~ 
-      |      |     |
-      |      |     (3) ...to here
-      |      |     (4) first 'free' here
-      |   NN |   if (y)
-      |      |      ~         
-      |      |      |
-      |      |      (5) following 'true' branch (when 'y != 0')...
-      |   NN |     free (ptr);
-      |      |     ~~~~~~~~~~ 
-      |      |     |
-      |      |     (6) ...to here
-      |      |     (7) second 'free' here; first 'free' was at (4)
-      |
+    |
+    |   NN |   void *ptr = malloc (1024);
+    |      |               ^~~~~~~~~~~~~
+    |      |               |
+    |      |               (1) allocated here
+    |   NN |   if (x)
+    |      |      ~         
+    |      |      |
+    |      |      (2) following 'true' branch (when 'x != 0')...
+    |   NN |     free (ptr);
+    |      |     ~~~~~~~~~~ 
+    |      |     |
+    |      |     (3) ...to here
+    |      |     (4) first 'free' here
+    |   NN |   if (y)
+    |      |      ~         
+    |      |      |
+    |      |      (5) following 'true' branch (when 'y != 0')...
+    |   NN |     free (ptr);
+    |      |     ~~~~~~~~~~ 
+    |      |     |
+    |      |     (6) ...to here
+    |      |     (7) second 'free' here; first 'free' was at (4)
+    |
    { dg-end-multiline-output "" } */
 
 /* "leak of 'ptr'.  */
 /* { dg-begin-multiline-output "" }
+   NN | }
+      | ^
   'test_2': events 1-6
-      |
-      |   NN |   void *ptr = malloc (1024);
-      |      |               ^~~~~~~~~~~~~
-      |      |               |
-      |      |               (1) allocated here
-      |   NN |   if (x)
-      |      |      ~         
-      |      |      |
-      |      |      (2) following 'false' branch (when 'x == 0')...
-      |   NN |     free (ptr);
-      |   NN |   if (y)
-      |      |      ~         
-      |      |      |
-      |      |      (3) ...to here
-      |      |      (4) following 'false' branch (when 'y == 0')...
-      |   NN |     free (ptr);
-      |   NN | }
-      |      | ~              
-      |      | |
-      |      | (5) ...to here
-      |      | (6) 'ptr' leaks here; was allocated at (1)
-      |
+    |
+    |   NN |   void *ptr = malloc (1024);
+    |      |               ^~~~~~~~~~~~~
+    |      |               |
+    |      |               (1) allocated here
+    |   NN |   if (x)
+    |      |      ~         
+    |      |      |
+    |      |      (2) following 'false' branch (when 'x == 0')...
+    |   NN |     free (ptr);
+    |   NN |   if (y)
+    |      |      ~         
+    |      |      |
+    |      |      (3) ...to here
+    |      |      (4) following 'false' branch (when 'y == 0')...
+    |   NN |     free (ptr);
+    |   NN | }
+    |      | ~              
+    |      | |
+    |      | (5) ...to here
+    |      | (6) 'ptr' leaks here; was allocated at (1)
+    |
    { dg-end-multiline-output "" } */
 
 int test_3 (int x, int y)
@@ -111,172 +117,182 @@ int test_3 (int x, int y)
 
 /* "dereference of possibly-NULL 'ptr'".  */
 /* { dg-begin-multiline-output "" }
+   NN |   *ptr = 42;
+      |   ~~~~~^~~~
   'test_3': events 1-2
-      |
-      |   NN |   int *ptr = (int *)malloc (sizeof (int));
-      |      |                     ^~~~~~~~~~~~~~~~~~~~~
-      |      |                     |
-      |      |                     (1) this call could return NULL
-      |   NN |   *ptr = 42;
-      |      |   ~~~~~~~~~          
-      |      |        |
-      |      |        (2) 'ptr' could be NULL
-      |
+    |
+    |   NN |   int *ptr = (int *)malloc (sizeof (int));
+    |      |                     ^~~~~~~~~~~~~~~~~~~~~
+    |      |                     |
+    |      |                     (1) this call could return NULL
+    |   NN |   *ptr = 42;
+    |      |   ~~~~~~~~~          
+    |      |        |
+    |      |        (2) 'ptr' could be NULL: unchecked value from (1)
+    |
    { dg-end-multiline-output "" } */
 
 /* "use after 'free' of 'ptr'".  */
 /* { dg-begin-multiline-output "" }
+   NN |   *ptr = 19;
+      |   ~~~~~^~~~
   'test_3': events 1-6
-      |
-      |   NN |   int *ptr = (int *)malloc (sizeof (int));
-      |      |                     ^~~~~~~~~~~~~~~~~~~~~
-      |      |                     |
-      |      |                     (1) allocated here
-      |   NN |   *ptr = 42;
-      |      |   ~~~~~~~~~          
-      |      |        |
-      |      |        (2) assuming 'ptr' is non-NULL
-      |   NN |   if (x)
-      |      |      ~               
-      |      |      |
-      |      |      (3) following 'true' branch (when 'x != 0')...
-      |   NN |     free (ptr);
-      |      |     ~~~~~~~~~~       
-      |      |     |
-      |      |     (4) ...to here
-      |      |     (5) freed here
-      |   NN | 
-      |   NN |   *ptr = 19;
-      |      |   ~~~~~~~~~          
-      |      |        |
-      |      |        (6) use after 'free' of 'ptr'; freed at (5)
-      |
+    |
+    |   NN |   int *ptr = (int *)malloc (sizeof (int));
+    |      |                     ^~~~~~~~~~~~~~~~~~~~~
+    |      |                     |
+    |      |                     (1) allocated here
+    |   NN |   *ptr = 42;
+    |      |   ~~~~~~~~~          
+    |      |        |
+    |      |        (2) assuming 'ptr' is non-NULL
+    |   NN |   if (x)
+    |      |      ~               
+    |      |      |
+    |      |      (3) following 'true' branch (when 'x != 0')...
+    |   NN |     free (ptr);
+    |      |     ~~~~~~~~~~       
+    |      |     |
+    |      |     (4) ...to here
+    |      |     (5) freed here
+    |   NN | 
+    |   NN |   *ptr = 19;
+    |      |   ~~~~~~~~~          
+    |      |        |
+    |      |        (6) use after 'free' of 'ptr'; freed at (5)
+    |
    { dg-end-multiline-output "" } */
 
-/* "dereference of freed pointer 'ptr'".  */
-/* { dg-begin-multiline-output "" }
-  'test_3': events 1-3
-      |
-      |   NN |   if (x)
-      |      |      ^
-      |      |      |
-      |      |      (1) following 'true' branch (when 'x != 0')...
-      |   NN |     free (ptr);
-      |      |     ~~~~~~~~~~
-      |      |     |
-      |      |     (2) ...to here
-      |   NN | 
-      |   NN |   *ptr = 19;
-      |      |   ~~~~~~~~~
-      |      |        |
-      |      |        (3) use after 'free' of 'ptr' here
-      |
-   { dg-end-multiline-output "" } */
-/* TODO: this is really a duplicate; can we either eliminate it, or
-   improve the path?  */
-
 /* "use after 'free' of 'ptr'".  */
 /* { dg-begin-multiline-output "" }
+   NN |   return *ptr;
+      |          ^~~~
   'test_3': events 1-8
-      |
-      |   NN |   int *ptr = (int *)malloc (sizeof (int));
-      |      |                     ^~~~~~~~~~~~~~~~~~~~~
-      |      |                     |
-      |      |                     (1) allocated here
-      |   NN |   *ptr = 42;
-      |      |   ~~~~~~~~~          
-      |      |        |
-      |      |        (2) assuming 'ptr' is non-NULL
-      |   NN |   if (x)
-      |      |      ~               
-      |      |      |
-      |      |      (3) following 'false' branch (when 'x == 0')...
-      |......
-      |   NN |   *ptr = 19;
-      |      |   ~~~~~~~~~          
-      |      |        |
-      |      |        (4) ...to here
-      |......
-      |   NN |   if (y)
-      |      |      ~               
-      |      |      |
-      |      |      (5) following 'true' branch (when 'y != 0')...
-      |   NN |     free (ptr);
-      |      |     ~~~~~~~~~~       
-      |      |     |
-      |      |     (6) ...to here
-      |      |     (7) freed here
-      |   NN |      to dereference it above
-      |   NN |   return *ptr;
-      |      |          ~~~~        
-      |      |          |
-      |      |          (8) use after 'free' of 'ptr'; freed at (7)
-      |
+    |
+    |   NN |   int *ptr = (int *)malloc (sizeof (int));
+    |      |                     ^~~~~~~~~~~~~~~~~~~~~
+    |      |                     |
+    |      |                     (1) allocated here
+    |   NN |   *ptr = 42;
+    |      |   ~~~~~~~~~          
+    |      |        |
+    |      |        (2) assuming 'ptr' is non-NULL
+    |   NN |   if (x)
+    |      |      ~               
+    |      |      |
+    |      |      (3) following 'false' branch (when 'x == 0')...
+    |......
+    |   NN |   *ptr = 19;
+    |      |   ~~~~~~~~~          
+    |      |        |
+    |      |        (4) ...to here
+    |......
+    |   NN |   if (y)
+    |      |      ~               
+    |      |      |
+    |      |      (5) following 'true' branch (when 'y != 0')...
+    |   NN |     free (ptr);
+    |      |     ~~~~~~~~~~       
+    |      |     |
+    |      |     (6) ...to here
+    |      |     (7) freed here
+    |   NN |      
+    |   NN |   return *ptr;
+    |      |          ~~~~        
+    |      |          |
+    |      |          (8) use after 'free' of 'ptr'; freed at (7)
+    |
    { dg-end-multiline-output "" } */
 
 /* "leak of 'ptr'".  */
 /* { dg-begin-multiline-output "" }
+   NN |   return *ptr;
+      |          ^~~~
   'test_3': events 1-7
-      |
-      |   NN |   int *ptr = (int *)malloc (sizeof (int));
-      |      |                     ^~~~~~~~~~~~~~~~~~~~~
-      |      |                     |
-      |      |                     (1) allocated here
-      |   NN |   *ptr = 42;
-      |      |   ~~~~~~~~~          
-      |      |        |
-      |      |        (2) assuming 'ptr' is non-NULL
-      |   NN |   if (x)
-      |      |      ~               
-      |      |      |
-      |      |      (3) following 'false' branch (when 'x == 0')...
-      |......
-      |   NN |   *ptr = 19;
-      |      |   ~~~~~~~~~          
-      |      |        |
-      |      |        (4) ...to here
-      |......
-      |   NN |   if (y)
-      |      |      ~               
-      |      |      |
-      |      |      (5) following 'false' branch (when 'y == 0')...
-      |......
-      |   NN |   return *ptr;
-      |      |          ~~~~        
-      |      |          |
-      |      |          (6) ...to here
-      |      |          (7) 'ptr' leaks here; was allocated at (1)
-      |
+    |
+    |   NN |   int *ptr = (int *)malloc (sizeof (int));
+    |      |                     ^~~~~~~~~~~~~~~~~~~~~
+    |      |                     |
+    |      |                     (1) allocated here
+    |   NN |   *ptr = 42;
+    |      |   ~~~~~~~~~          
+    |      |        |
+    |      |        (2) assuming 'ptr' is non-NULL
+    |   NN |   if (x)
+    |      |      ~               
+    |      |      |
+    |      |      (3) following 'false' branch (when 'x == 0')...
+    |......
+    |   NN |   *ptr = 19;
+    |      |   ~~~~~~~~~          
+    |      |        |
+    |      |        (4) ...to here
+    |......
+    |   NN |   if (y)
+    |      |      ~               
+    |      |      |
+    |      |      (5) following 'false' branch (when 'y == 0')...
+    |......
+    |   NN |   return *ptr;
+    |      |          ~~~~        
+    |      |          |
+    |      |          (6) ...to here
+    |      |          (7) 'ptr' leaks here; was allocated at (1)
+    |
    { dg-end-multiline-output "" } */
 
-/* "dereference of freed pointer 'ptr'".  */
+/* "use after 'free' of 'ptr'".  */
+/* { dg-begin-multiline-output "" }
+   NN |   *ptr = 19;
+      |   ~~~~~^~~~
+  'test_3': events 1-3
+    |
+    |   NN |   if (x)
+    |      |      ^
+    |      |      |
+    |      |      (1) following 'true' branch (when 'x != 0')...
+    |   NN |     free (ptr);
+    |      |     ~~~~~~~~~~
+    |      |     |
+    |      |     (2) ...to here
+    |   NN | 
+    |   NN |   *ptr = 19;
+    |      |   ~~~~~~~~~
+    |      |        |
+    |      |        (3) use after 'free' of 'ptr' here
+    |
+   { dg-end-multiline-output "" } */
+
+/* "use after 'free' of 'ptr'".  */
 /* { dg-begin-multiline-output "" }
+   NN |   return *ptr;
+      |          ^~~~
   'test_3': events 1-5
-      |
-      |   NN |   if (x)
-      |      |      ^
-      |      |      |
-      |      |      (1) following 'false' branch (when 'x == 0')...
-      |......
-      |   NN |   *ptr = 19;
-      |      |   ~~~~~~~~~
-      |      |        |
-      |      |        (2) ...to here
-      |......
-      |   NN |   if (y)
-      |      |      ~
-      |      |      |
-      |      |      (3) following 'true' branch (when 'y != 0')...
-      |   NN |     free (ptr);
-      |      |     ~~~~~~~~~~
-      |      |     |
-      |      |     (4) ...to here
-      |   NN |      to dereference it above
-      |   NN |   return *ptr;
-      |      |          ~~~~
-      |      |          |
-      |      |          (5) use after 'free' of 'ptr' here
-      |
+    |
+    |   NN |   if (x)
+    |      |      ^
+    |      |      |
+    |      |      (1) following 'false' branch (when 'x == 0')...
+    |......
+    |   NN |   *ptr = 19;
+    |      |   ~~~~~~~~~
+    |      |        |
+    |      |        (2) ...to here
+    |......
+    |   NN |   if (y)
+    |      |      ~
+    |      |      |
+    |      |      (3) following 'true' branch (when 'y != 0')...
+    |   NN |     free (ptr);
+    |      |     ~~~~~~~~~~
+    |      |     |
+    |      |     (4) ...to here
+    |   NN |      to dereference it above
+    |   NN |   return *ptr;
+    |      |          ~~~~
+    |      |          |
+    |      |          (5) use after 'free' of 'ptr' here
+    |
    { dg-end-multiline-output "" } */
 /* TODO: this is really a duplicate; can we either eliminate it, or
    improve the path?  */
diff --git a/gcc/testsuite/gcc.dg/analyzer/setjmp-2.c b/gcc/testsuite/gcc.dg/analyzer/setjmp-2.c
index c5fb915..7afe66e 100644
--- a/gcc/testsuite/gcc.dg/analyzer/setjmp-2.c
+++ b/gcc/testsuite/gcc.dg/analyzer/setjmp-2.c
@@ -1,4 +1,4 @@
-/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events" } */
+/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fdiagnostics-show-caret" } */
 
 #include <setjmp.h>
 #include <stddef.h>
@@ -33,49 +33,51 @@ void test_2 (void)
 }
 
 /* { dg-begin-multiline-output "" }
+   NN |       __analyzer_dump_path ();
+      |       ^~~~~~~~~~~~~~~~~~~~~~~
   'test_2': event 1
-      |
-      |   NN |   i = setjmp(env);
-      |      |       ^~~~~~
-      |      |       |
-      |      |       (1) 'setjmp' called here
-      |
+    |
+    |   NN |   i = setjmp(env);
+    |      |       ^~~~~~
+    |      |       |
+    |      |       (1) 'setjmp' called here
+    |
   'test_2': events 2-4
-      |
-      |   NN |   if (i != 0)
-      |      |      ^
-      |      |      |
-      |      |      (2) following 'false' branch (when 'i == 0')...
-      |......
-      |   NN |     longjmp (env, 1);
-      |      |     ~~~~~~~~~~~~~~~~
-      |      |     |
-      |      |     (3) ...to here
-      |      |     (4) rewinding within 'test_2' from 'longjmp'...
-      |
+    |
+    |   NN |   if (i != 0)
+    |      |      ^
+    |      |      |
+    |      |      (2) following 'false' branch (when 'i == 0')...
+    |......
+    |   NN |     longjmp (env, 1);
+    |      |     ~~~~~~~~~~~~~~~~
+    |      |     |
+    |      |     (3) ...to here
+    |      |     (4) rewinding within 'test_2' from 'longjmp'...
+    |
   'test_2': event 5
-      |
-      |   NN |   i = setjmp(env);
-      |      |       ^~~~~~
-      |      |       |
-      |      |       (5) ...to 'setjmp' (saved at (1))
-      |
+    |
+    |   NN |   i = setjmp(env);
+    |      |       ^~~~~~
+    |      |       |
+    |      |       (5) ...to 'setjmp' (saved at (1))
+    |
   'test_2': events 6-8
-      |
-      |   NN |   if (i != 0)
-      |      |      ^
-      |      |      |
-      |      |      (6) following 'true' branch (when 'i != 0')...
-      |   NN |     {
-      |   NN |       foo (2);
-      |      |       ~~~~~~~
-      |      |       |
-      |      |       (7) ...to here
-      |   NN |       __analyzer_dump_path ();
-      |      |       ~~~~~~~~~~~~~~~~~~~~~~~
-      |      |       |
-      |      |       (8) here
-      |
+    |
+    |   NN |   if (i != 0)
+    |      |      ^
+    |      |      |
+    |      |      (6) following 'true' branch (when 'i != 0')...
+    |   NN |     {
+    |   NN |       foo (2);
+    |      |       ~~~~~~~
+    |      |       |
+    |      |       (7) ...to here
+    |   NN |       __analyzer_dump_path ();
+    |      |       ~~~~~~~~~~~~~~~~~~~~~~~
+    |      |       |
+    |      |       (8) here
+    |
     { dg-end-multiline-output "" } */
 
 void test_3 (void)
diff --git a/gcc/testsuite/gcc.dg/analyzer/setjmp-3.c b/gcc/testsuite/gcc.dg/analyzer/setjmp-3.c
index f40ee7f..6f67ff5 100644
--- a/gcc/testsuite/gcc.dg/analyzer/setjmp-3.c
+++ b/gcc/testsuite/gcc.dg/analyzer/setjmp-3.c
@@ -1,4 +1,4 @@
-/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events" } */
+/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fdiagnostics-show-caret" } */
 
 #include <setjmp.h>
 #include <stddef.h>
@@ -34,71 +34,73 @@ void outer (void)
 }
 
 /* { dg-begin-multiline-output "" }
+   NN |       __analyzer_dump_path ();
+      |       ^~~~~~~~~~~~~~~~~~~~~~~
   'outer': event 1
-     |
-     |   NN | void outer (void)
-     |      |      ^~~~~
-     |      |      |
-     |      |      (1) entry to 'outer'
-     |
+    |
+    |   NN | void outer (void)
+    |      |      ^~~~~
+    |      |      |
+    |      |      (1) entry to 'outer'
+    |
   'outer': event 2
-     |
-     |   NN |   i = setjmp(env);
-     |      |       ^~~~~~
-     |      |       |
-     |      |       (2) 'setjmp' called here
-     |
+    |
+    |   NN |   i = setjmp(env);
+    |      |       ^~~~~~
+    |      |       |
+    |      |       (2) 'setjmp' called here
+    |
   'outer': events 3-5
-     |
-     |   NN |   if (i != 0)
-     |      |      ^
-     |      |      |
-     |      |      (3) following 'false' branch (when 'i == 0')...
-     |......
-     |   NN |       foo (1);
-     |      |       ~~~~~~~
-     |      |       |
-     |      |       (4) ...to here
-     |   NN |       inner ();
-     |      |       ~~~~~~~~
-     |      |       |
-     |      |       (5) calling 'inner' from 'outer'
-     |
-     +--> 'inner': events 6-7
-             |
-             |   NN | static void inner (void)
-             |      |             ^~~~~
-             |      |             |
-             |      |             (6) entry to 'inner'
-             |   NN | {
-             |   NN |   longjmp (env, 1);
-             |      |   ~~~~~~~~~~~~~~~~
-             |      |   |
-             |      |   (7) rewinding from 'longjmp' in 'inner'...
-             |
-     <-------+
-     |
+    |
+    |   NN |   if (i != 0)
+    |      |      ^
+    |      |      |
+    |      |      (3) following 'false' branch (when 'i == 0')...
+    |......
+    |   NN |       foo (1);
+    |      |       ~~~~~~~
+    |      |       |
+    |      |       (4) ...to here
+    |   NN |       inner ();
+    |      |       ~~~~~~~~
+    |      |       |
+    |      |       (5) calling 'inner' from 'outer'
+    |
+    +--> 'inner': events 6-7
+           |
+           |   NN | static void inner (void)
+           |      |             ^~~~~
+           |      |             |
+           |      |             (6) entry to 'inner'
+           |   NN | {
+           |   NN |   longjmp (env, 1);
+           |      |   ~~~~~~~~~~~~~~~~
+           |      |   |
+           |      |   (7) rewinding from 'longjmp' in 'inner'...
+           |
+    <------+
+    |
   'outer': event 8
-     |
-     |   NN |   i = setjmp(env);
-     |      |       ^~~~~~
-     |      |       |
-     |      |       (8) ...to 'setjmp' in 'outer' (saved at (2))
-     |
+    |
+    |   NN |   i = setjmp(env);
+    |      |       ^~~~~~
+    |      |       |
+    |      |       (8) ...to 'setjmp' in 'outer' (saved at (2))
+    |
   'outer': events 9-11
-     |
-     |   NN |   if (i != 0)
-     |      |      ^
-     |      |      |
-     |      |      (9) following 'true' branch (when 'i != 0')...
-     |   NN |     {
-     |   NN |       foo (2);
-     |      |       ~~~~~~~
-     |      |       |
-     |      |       (10) ...to here
-     |   NN |       __analyzer_dump_path ();
-     |      |       ~~~~~~~~~~~~~~~~~~~~~~~
-     |      |       |
-     |      |       (11) here
-     |
+    |
+    |   NN |   if (i != 0)
+    |      |      ^
+    |      |      |
+    |      |      (9) following 'true' branch (when 'i != 0')...
+    |   NN |     {
+    |   NN |       foo (2);
+    |      |       ~~~~~~~
+    |      |       |
+    |      |       (10) ...to here
+    |   NN |       __analyzer_dump_path ();
+    |      |       ~~~~~~~~~~~~~~~~~~~~~~~
+    |      |       |
+    |      |       (11) here
+    |
     { dg-end-multiline-output "" } */
diff --git a/gcc/testsuite/gcc.dg/analyzer/setjmp-4.c b/gcc/testsuite/gcc.dg/analyzer/setjmp-4.c
index 01f5208..21bb87e 100644
--- a/gcc/testsuite/gcc.dg/analyzer/setjmp-4.c
+++ b/gcc/testsuite/gcc.dg/analyzer/setjmp-4.c
@@ -1,4 +1,4 @@
-/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events" } */
+/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fdiagnostics-show-caret" } */
 
 #include <setjmp.h>
 
@@ -29,77 +29,79 @@ int main (void)
 }
 
 /* { dg-begin-multiline-output "" }
+   NN |     __analyzer_dump_path ();
+      |     ^~~~~~~~~~~~~~~~~~~~~~~
   'main': event 1
-     |
-     |   NN | int main (void)
-     |      |     ^~~~
-     |      |     |
-     |      |     (1) entry to 'main'
-     |
+    |
+    |   NN | int main (void)
+    |      |     ^~~~
+    |      |     |
+    |      |     (1) entry to 'main'
+    |
   'main': event 2
-     |
-     |   NN |   if (!setjmp(buf))
-     |      |        ^~~~~~
-     |      |        |
-     |      |        (2) 'setjmp' called here
-     |
+    |
+    |   NN |   if (!setjmp(buf))
+    |      |        ^~~~~~
+    |      |        |
+    |      |        (2) 'setjmp' called here
+    |
   'main': events 3-5
-     |
-     |   NN |   if (!setjmp(buf))
-     |      |      ^
-     |      |      |
-     |      |      (3) following 'true' branch...
-     |   NN |     outer (42);
-     |      |     ~~~~~~~~~~
-     |      |     |
-     |      |     (4) ...to here
-     |      |     (5) calling 'outer' from 'main'
-     |
-     +--> 'outer': events 6-7
-             |
-             |   NN | void outer (int y)
-             |      |      ^~~~~
-             |      |      |
-             |      |      (6) entry to 'outer'
-             |......
-             |   NN |   inner (y);
-             |      |   ~~~~~~~~~
-             |      |   |
-             |      |   (7) calling 'inner' from 'outer'
-             |
-             +--> 'inner': events 8-9
-                     |
-                     |   NN | void inner (int x)
-                     |      |      ^~~~~
-                     |      |      |
-                     |      |      (8) entry to 'inner'
-                     |......
-                     |   NN |   longjmp (buf, 1);
-                     |      |   ~~~~~~~~~~~~~~~~
-                     |      |   |
-                     |      |   (9) rewinding from 'longjmp' in 'inner'...
-                     |
-     <---------------+
-     |
+    |
+    |   NN |   if (!setjmp(buf))
+    |      |      ^
+    |      |      |
+    |      |      (3) following 'true' branch...
+    |   NN |     outer (42);
+    |      |     ~~~~~~~~~~
+    |      |     |
+    |      |     (4) ...to here
+    |      |     (5) calling 'outer' from 'main'
+    |
+    +--> 'outer': events 6-7
+           |
+           |   NN | void outer (int y)
+           |      |      ^~~~~
+           |      |      |
+           |      |      (6) entry to 'outer'
+           |......
+           |   NN |   inner (y);
+           |      |   ~~~~~~~~~
+           |      |   |
+           |      |   (7) calling 'inner' from 'outer'
+           |
+           +--> 'inner': events 8-9
+                  |
+                  |   NN | void inner (int x)
+                  |      |      ^~~~~
+                  |      |      |
+                  |      |      (8) entry to 'inner'
+                  |......
+                  |   NN |   longjmp (buf, 1);
+                  |      |   ~~~~~~~~~~~~~~~~
+                  |      |   |
+                  |      |   (9) rewinding from 'longjmp' in 'inner'...
+                  |
+    <-------------+
+    |
   'main': event 10
-     |
-     |   NN |   if (!setjmp(buf))
-     |      |        ^~~~~~
-     |      |        |
-     |      |        (10) ...to 'setjmp' in 'main' (saved at (2))
-     |
+    |
+    |   NN |   if (!setjmp(buf))
+    |      |        ^~~~~~
+    |      |        |
+    |      |        (10) ...to 'setjmp' in 'main' (saved at (2))
+    |
   'main': events 11-13
-     |
-     |   NN |   if (!setjmp(buf))
-     |      |      ^
-     |      |      |
-     |      |      (11) following 'false' branch...
-     |......
-     |   NN |     __analyzer_dump_path ();
-     |      |     ~~~~~~~~~~~~~~~~~~~~~~~
-     |      |     |
-     |      |     (12) ...to here
-     |      |     (13) here
-     |
+    |
+    |   NN |   if (!setjmp(buf))
+    |      |      ^
+    |      |      |
+    |      |      (11) following 'false' branch...
+    |......
+    |   NN |     __analyzer_dump_path ();
+    |      |     ~~~~~~~~~~~~~~~~~~~~~~~
+    |      |     |
+    |      |     (12) ...to here
+    |      |     (13) here
+    |
     { dg-end-multiline-output "" } */
 
diff --git a/gcc/testsuite/gcc.dg/analyzer/setjmp-5.c b/gcc/testsuite/gcc.dg/analyzer/setjmp-5.c
index 2180f47..faac51c 100644
--- a/gcc/testsuite/gcc.dg/analyzer/setjmp-5.c
+++ b/gcc/testsuite/gcc.dg/analyzer/setjmp-5.c
@@ -1,4 +1,4 @@
-/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events" } */
+/* { dg-additional-options "-fdiagnostics-show-line-numbers -fdiagnostics-nn-line-numbers -fdiagnostics-path-format=inline-events -fdiagnostics-show-caret" } */
 
 #include <setjmp.h>
 #include <stddef.h>
@@ -20,44 +20,46 @@ void outer (void)
 }
 
 /* { dg-begin-multiline-output "" }
+   NN |   longjmp (env, 42);
+      |   ^~~~~~~~~~~~~~~~~
   'outer': events 1-2
-     |
-     |   NN | void outer (void)
-     |      |      ^~~~~
-     |      |      |
-     |      |      (1) entry to 'outer'
-     |......
-     |   NN |   inner ();
-     |      |   ~~~~~~~~
-     |      |   |
-     |      |   (2) calling 'inner' from 'outer'
-     |
-     +--> 'inner': event 3
-             |
-             |   NN | static void inner (void)
-             |      |             ^~~~~
-             |      |             |
-             |      |             (3) entry to 'inner'
-             |
-          'inner': event 4
-             |
-             |   NN |   setjmp (env);
-             |      |   ^~~~~~
-             |      |   |
-             |      |   (4) 'setjmp' called here
-             |
-     <-------+
-     |
+    |
+    |   NN | void outer (void)
+    |      |      ^~~~~
+    |      |      |
+    |      |      (1) entry to 'outer'
+    |......
+    |   NN |   inner ();
+    |      |   ~~~~~~~~
+    |      |   |
+    |      |   (2) calling 'inner' from 'outer'
+    |
+    +--> 'inner': event 3
+           |
+           |   NN | static void inner (void)
+           |      |             ^~~~~
+           |      |             |
+           |      |             (3) entry to 'inner'
+           |
+         'inner': event 4
+           |
+           |   NN |   setjmp (env);
+           |      |   ^~~~~~
+           |      |   |
+           |      |   (4) 'setjmp' called here
+           |
+    <------+
+    |
   'outer': events 5-6
-     |
-     |   NN |   inner ();
-     |      |   ^~~~~~~~
-     |      |   |
-     |      |   (5) returning to 'outer' from 'inner'
-     |   NN | 
-     |   NN |   longjmp (env, 42);
-     |      |   ~~~~~~~~~~~~~~~~~
-     |      |   |
-     |      |   (6) here
-     |
+    |
+    |   NN |   inner ();
+    |      |   ^~~~~~~~
+    |      |   |
+    |      |   (5) returning to 'outer' from 'inner'
+    |   NN | 
+    |   NN |   longjmp (env, 42);
+    |      |   ~~~~~~~~~~~~~~~~~
+    |      |   |
+    |      |   (6) here
+    |
     { dg-end-multiline-output "" } */
